/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

#include "supportfuncs.h"
#include "celldb_form.h"
#include <qinputdialog.h>
#include <qmessagebox.h>
#include <qapplication.h>

void cell_form::activate_but_clicked()
{
   extern celldb_form * w_db_ptr;

   dbCellUpdate();

   fprintf(stderr, "Activate clicked\n");
   
   int item =
      celllist_box->currentItem();
   fprintf(stderr, "Customize Item: %d\n", item);
   
   if(item >= 0) {
      bool found;
      xmlNodePtr node = dbExists(found, cells[item]);
      //TODO- override with potential newly iwlist values
      Cell cell;
      if(node)
         cell.populatefrom(node);
      if(!found) {
         cells[item].sh_run = cell.sh_run;
         cell = cells[item];

         /* if encrypted, must ask for more info */
         if(cell.encrypted == string("yes")) {
         bool ok;
         QString text = 
            QInputDialog::getText(
                                  "netchooser", "Connection is Encrypted. Enter key:", 
                                  QLineEdit::Normal,
                                  QString::null, &ok, this );
         
         if ( ok && !text.isEmpty() ) {
            cell.key = text.ascii();
         } else {
            return;
         }
         }

         if(cell.activate() != 0) {
            extern bool dbNeedSave;
            cell.do_dhcp = string();
            dbAdd(cell);
            dbNeedSave = true;
            w_db_ptr->show();
            dbDisplay(cell.xmlnode);
            QMessageBox::information( this, "netchooser",
                                      "DHCP failed. Please fill out ip/netmask/gateway/nameserver\n   fields in database window and click activate again." );
            return;
         } else {

         if((cell.key != string()) || (cell.do_dhcp == string()))
         if(!QMessageBox::question(this,
                                  "netchooser",
                                  "Do you want to save this network in the database?",
                                   "&Yes", "&No",
                                   QString::null, 0, 1 ) ) {
            dbAdd(cell);
            dbWrite();
         }
         return;
         }

      }
      cell.activate();
   }
}


void cell_form::refresh_but_clicked()
{
   refresh_cells(celllist_box); 
}


void cell_form::customize_but_clicked()
{
   extern celldb_form * w_db_ptr;
   int item =
      celllist_box->currentItem();
   fprintf(stderr, "Customize Item: %d\n", item);
  
   if(item >= 0) {
      bool found;
      xmlNodePtr node = dbExists(found, cells[item]);
      if(!found) {
         dbAdd(cells[item]);
         cells[item].totable();
      } else {
         //TODO- check for differences from cells[item]
         dbDisplay(node);
      }
      w_db_ptr->show();
   }
}


void cell_form::editdb_but_clicked()
{
   extern celldb_form * w_db_ptr;
   if(dbGetFirst()) {
      dbDisplay(dbGetFirst());
      w_db_ptr->show();
   }
}


void cell_form::closeEvent( QCloseEvent * e )
{
   extern bool dbNeedSave;
   extern QApplication* a_ptr;

   fprintf(stderr, "Cell_form_destroyed\n");

   if(dbNeedSave) {
      if(!QMessageBox::question(this,
                                "netchooser",
                                "Do you want to save database changes?",
                                "&Yes", "&No",
                                QString::null, 0, 1 ) ) {
         dbCellUpdate();
         dbWrite();
      }
   }

   QDialog::closeEvent(e);
   a_ptr->quit();
   //a_ptr->exec();

}
