/* Copyright (C) 2005 E.Berta

netchoose is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

netchoose is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#include <qapplication.h>
#include "cell_form.h"
#include "celldb_form.h"
#include "supportfuncs.h"

cell_form * w_ptr;
celldb_form * w_db_ptr;
QApplication* a_ptr;

int main( int argc, char ** argv )
{
    QApplication a( argc, argv );
    char  newpath[2048];
    char * pathstr = getenv("PATH");
    
    if(pathstr)
       sprintf(newpath, "%s:/sbin:/usr/sbin", pathstr);
    else
       strcpy(newpath, "/sbin:/usr/sbin");

    setenv("PATH", newpath, 1);

    a_ptr = &a;

    dbRead();

    cell_form w;
    celldb_form w_db;
    
    w_ptr = &w;
    w_db_ptr = &w_db;

    w_db.required_table->setColumnWidth(0, 165);
    w_db.manual_table->setColumnWidth(0, 150);

    w.show();
    w.refresh_but_clicked();

    //w_db.show();

    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    return a.exec();
}
