/* Copyright (C) 2005 E.Berta

netchoose is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

netchoose is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.
*/

#ifndef SUPPORTFUNCS_H
#define SUPPORTFUNCS_H

#include <string>
#include <vector>

#include <qlistbox.h>
#include <qtable.h>
#include <qtextedit.h>
#include <qcheckbox.h>

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

using namespace std;

class Cell {
public:

   string interface;
   string address;
   string essid;
   string mode;
   string channel;
   string encrypted;
   string bit_rate;
   string quality;
   string signal_level;

   string key;
   string do_dhcp;
   string ip;
   string netmask;
   string gateway;
   string nameserver;
   string sh_run;

   xmlNodePtr xmlnode;

   Cell() : do_dhcp("yes"), sh_run("/usr/local/share/netchoose/activate.sh"), xmlnode(NULL) {}

   string touserstring();
   
   void populatefrom(xmlNodePtr node, bool clearcur = true);
   
   xmlNodePtr makeNewNode();

   void setnode(xmlNodePtr cellnode) const;

   void totable() const;

   void fromtable();

   int activate();

};

int refresh_cells(QListBox* celllist_box);

void dbAdd(Cell& cell);
void dbRemove(xmlNodePtr node = NULL);
xmlNodePtr dbExists(bool& found, const Cell& cell);
void dbWrite();
void dbRead();
void dbDisplay(xmlNodePtr cellnode);
xmlNodePtr dbGetFirst();
void dbCellUpdate();

xmlNodePtr getNextElement(xmlNodePtr cur);
xmlNodePtr getPrevElement(xmlNodePtr cur);


extern vector<Cell> cells;
extern Cell dbCell;

#endif
